package gateway

import (
	"shylinux.com/x/ice"
	"shylinux.com/x/icebergs/base/ctx"
	"shylinux.com/x/icebergs/base/mdb"
	"shylinux.com/x/icebergs/base/web"
	kit "shylinux.com/x/toolkits"
)

type Process struct {
	Gateway
	list string `name:"list index auto" help:"功能模块"`
}

func (s Process) Weight(m *ice.Message, arg ...string) {
	m.Cmdy("").DisplayStoryWeight().Action(s.Weight)
}
func (s Process) List(m *ice.Message, arg ...string) {
	if len(arg) == 0 {
		func() {
			defer web.InfoLock.Lock()()
			kit.For(web.Info.Commands, func(key string, value int) {
				m.Push(ctx.INDEX, key).Push(mdb.COUNT, value)
			})
		}()
		m.PushAction(s.Preview).Action(s.Foreach, s.Weight).SortIntR(mdb.COUNT)
	} else {
		m.ProcessField(arg[0], nil)
	}
}
func (s Process) Preview(m *ice.Message, arg ...string) {
	m.ProcessPodCmd(m.Option(web.SPACE), m.Option(ctx.INDEX), nil, arg...)
}

func init() { ice.Cmd("web.chat.dev.service.process", Process{}) }
